var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, Injector, ReflectiveInjector } from '@angular/core';
import * as firebase from 'firebase';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { NativeFirebaseAuth, NativeFirebaseDatabase } from './native-firebase';
import { wrapPromise } from './utils';
var lastAppId = 0;
var FirebaseAppConfig = (function () {
    function FirebaseAppConfig(config) {
        this.token = config.token;
        this.name = config.name || "app-" + lastAppId++;
        this.options = config.options;
    }
    return FirebaseAppConfig;
}());
export { FirebaseAppConfig };
var FirebaseApp = (function () {
    function FirebaseApp(config, injector) {
        this.config = config;
        this.injector = injector;
        this.nativeApp = firebase.initializeApp(config.options, config.name);
    }
    FirebaseApp.prototype.delete = function () {
        var _this = this;
        return wrapPromise(function () { return _this.nativeApp.delete(); });
    };
    FirebaseApp.prototype.auth = function () {
        if (!this._auth) {
            var authInjector = ReflectiveInjector.resolveAndCreate([
                {
                    provide: NativeFirebaseAuth,
                    useValue: this.nativeApp.auth()
                },
                FirebaseAuth
            ], this.injector);
            this._auth = authInjector.get(FirebaseAuth);
        }
        return this._auth;
    };
    FirebaseApp.prototype.database = function () {
        if (!this._database) {
            var databaseInjector = ReflectiveInjector.resolveAndCreate([
                {
                    provide: NativeFirebaseDatabase,
                    useValue: this.nativeApp.database()
                },
                FirebaseDatabase
            ], this.injector);
            this._database = databaseInjector.get(FirebaseDatabase);
        }
        return this._database;
    };
    return FirebaseApp;
}());
FirebaseApp = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [FirebaseAppConfig,
        Injector])
], FirebaseApp);
export { FirebaseApp };
//# sourceMappingURL=firebase-app.service.js.map