var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone, Injector, ReflectiveInjector } from '@angular/core';
import { Observable } from 'rxjs';
import { NativeFirebaseDatabase } from './native-firebase';
import { wrapPromise } from './utils';
import { DataSnapshotObservable } from './observable/data-snapshot-observable';
import './observable/add/run-in-zone';
var Event = (function () {
    function Event() {
    }
    return Event;
}());
export { Event };
Event.Value = 'value';
Event.ChildAdded = 'child_added';
Event.ChildChanged = 'child_changed';
Event.ChildRemoved = 'child_removed';
Event.ChildMoved = 'child_moved';
var FirebaseQuery = (function () {
    function FirebaseQuery(_ref, ngZone) {
        this._ref = _ref;
        this.ngZone = ngZone;
    }
    Object.defineProperty(FirebaseQuery.prototype, "ref", {
        get: function () {
            return this.wrappedRef;
        },
        enumerable: true,
        configurable: true
    });
    FirebaseQuery.prototype.orderByChild = function (child) {
        this._call('orderByChild', child);
        return this;
    };
    FirebaseQuery.prototype.orderByKey = function () {
        this._call('orderByKey');
        return this;
    };
    FirebaseQuery.prototype.orderByPriority = function () {
        this._call('orderByPriority');
        return this;
    };
    FirebaseQuery.prototype.orderByValue = function () {
        this._call('orderByValue');
        return this;
    };
    FirebaseQuery.prototype.startAt = function (value, key) {
        this._call('startAt', value, key);
        return this;
    };
    FirebaseQuery.prototype.endAt = function (value, key) {
        this._call('endAt', value, key);
        return this;
    };
    FirebaseQuery.prototype.equalTo = function (value, key) {
        this._call('equalTo', value, key);
        return this;
    };
    FirebaseQuery.prototype.limitToFirst = function (limit) {
        this._call('limitToFirst', limit);
        return this;
    };
    FirebaseQuery.prototype.limitToLast = function (limit) {
        this._call('limitToLast', limit);
        return this;
    };
    FirebaseQuery.prototype.once = function (event) {
        var _this = this;
        return new DataSnapshotObservable(function (sub) {
            _this.getQueryOrRef().once(event, _this.getEventHandler(sub, true), function (err) { return function () { return sub.error(err); }; });
        }).runInZone(this.ngZone);
    };
    FirebaseQuery.prototype.onceValue = function () {
        return this.once(Event.Value);
    };
    FirebaseQuery.prototype.onceChildAdded = function () {
        return this.once(Event.ChildAdded);
    };
    FirebaseQuery.prototype.onceChildChanged = function () {
        return this.once(Event.ChildChanged);
    };
    FirebaseQuery.prototype.onceChildMoved = function () {
        return this.once(Event.ChildMoved);
    };
    FirebaseQuery.prototype.onceChildRemoved = function () {
        return this.once(Event.ChildRemoved);
    };
    FirebaseQuery.prototype.on = function (event) {
        var _this = this;
        return new DataSnapshotObservable(function (sub) {
            var cb = _this.getQueryOrRef().on(event, _this.getEventHandler(sub), function (err) { return sub.error(err); });
            return function () { return _this.getQueryOrRef().off(event, cb); };
        }).runInZone(this.ngZone);
    };
    FirebaseQuery.prototype.onValue = function () {
        return this.on(Event.Value);
    };
    FirebaseQuery.prototype.onChildAdded = function () {
        return this.on(Event.ChildAdded);
    };
    FirebaseQuery.prototype.onChildChanged = function () {
        return this.on(Event.ChildChanged);
    };
    FirebaseQuery.prototype.onChildMoved = function () {
        return this.on(Event.ChildMoved);
    };
    FirebaseQuery.prototype.onChildRemoved = function () {
        return this.on(Event.ChildRemoved);
    };
    FirebaseQuery.prototype.isEqual = function (query) {
        return this.getQueryOrRef().isEqual(query.getQueryOrRef());
    };
    FirebaseQuery.prototype.getEventHandler = function (sub, complete) {
        return function (snapshot, prevKey) {
            snapshot.prevKey = prevKey;
            sub.next(snapshot);
            if (complete) {
                sub.complete();
            }
        };
    };
    FirebaseQuery.prototype.getQueryOrRef = function () {
        if (this.query) {
            return this.query;
        }
        return this._ref;
    };
    FirebaseQuery.prototype._call = function (fnName) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this.query) {
            this.query = (_a = this.query)[fnName].apply(_a, args);
        }
        else {
            this.query = (_b = this._ref)[fnName].apply(_b, args);
        }
        var _a, _b;
    };
    return FirebaseQuery;
}());
export { FirebaseQuery };
var FirebaseDatabaseRefConfig = (function () {
    function FirebaseDatabaseRefConfig(parent, ref) {
        this.parent = parent;
        this.ref = ref;
    }
    return FirebaseDatabaseRefConfig;
}());
export { FirebaseDatabaseRefConfig };
var FirebaseDatabaseRef = FirebaseDatabaseRef_1 = (function (_super) {
    __extends(FirebaseDatabaseRef, _super);
    function FirebaseDatabaseRef(ngZone, config, injector) {
        var _this = _super.call(this, config.ref, ngZone) || this;
        _this.config = config;
        _this.injector = injector;
        _this.wrappedRef = _this;
        return _this;
    }
    FirebaseDatabaseRef.create = function (parent, injector, ref) {
        var childInjector = ReflectiveInjector.resolveAndCreate([
            {
                provide: FirebaseDatabaseRefConfig,
                useValue: new FirebaseDatabaseRefConfig(parent, ref),
            },
            FirebaseDatabaseRef_1
        ], injector);
        return childInjector.get(FirebaseDatabaseRef_1);
    };
    Object.defineProperty(FirebaseDatabaseRef.prototype, "key", {
        get: function () {
            return this._ref.key;
        },
        enumerable: true,
        configurable: true
    });
    FirebaseDatabaseRef.prototype.child = function (path) {
        return FirebaseDatabaseRef_1.create(this, this.injector, this._ref.child(path));
    };
    FirebaseDatabaseRef.prototype.set = function (value) {
        var _this = this;
        return wrapPromise(function () { return _this._ref.set(value); });
    };
    FirebaseDatabaseRef.prototype.setPriority = function (priority) {
        var _this = this;
        // There seems to be a bug with the typing for #setPriority(priority, onComplete): Promise
        // The firebase library, in every other case, declares the onComplete function optional since a
        // Promise is returned as well.
        return wrapPromise(function () { return _this._ref.setPriority(priority); });
    };
    FirebaseDatabaseRef.prototype.setWithPriority = function (newVal, priority) {
        var _this = this;
        return wrapPromise(function () { return _this._ref.setWithPriority(newVal, priority); });
    };
    FirebaseDatabaseRef.prototype.push = function (value) {
        var pushRef = this._ref.push(value);
        var ref = FirebaseDatabaseRef_1.create(this, this.injector, pushRef);
        // Only if a value to push was given, use ref as promise, since otherwise
        // pushRef.then will be undefined
        if (value) {
            return wrapPromise(function () { return pushRef; })
                .mapTo(ref);
        }
        return Observable.of(ref);
    };
    FirebaseDatabaseRef.prototype.update = function (value) {
        var _this = this;
        return wrapPromise(function () { return _this._ref.update(value); });
    };
    FirebaseDatabaseRef.prototype.remove = function () {
        var _this = this;
        return wrapPromise(function () { return _this._ref.remove(); });
    };
    FirebaseDatabaseRef.prototype.transaction = function (transactionUpdate, applyLocally) {
        var _this = this;
        return wrapPromise(function () { return new Promise(function (resolve, reject) { return _this._ref.transaction(transactionUpdate, function (err, committed, snapshot) { return err ? reject(err) : resolve({ committed: committed, snapshot: snapshot }); }, applyLocally); }); });
    };
    return FirebaseDatabaseRef;
}(FirebaseQuery));
FirebaseDatabaseRef = FirebaseDatabaseRef_1 = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [NgZone,
        FirebaseDatabaseRefConfig,
        Injector])
], FirebaseDatabaseRef);
export { FirebaseDatabaseRef };
var FirebaseDatabase = (function () {
    function FirebaseDatabase(db, injector) {
        this.db = db;
        this.injector = injector;
    }
    FirebaseDatabase.prototype.ref = function (path) {
        return FirebaseDatabaseRef.create(null, this.injector, this.db.ref(path));
    };
    return FirebaseDatabase;
}());
FirebaseDatabase = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [NativeFirebaseDatabase,
        Injector])
], FirebaseDatabase);
export { FirebaseDatabase };
var FirebaseDatabaseRef_1;
//# sourceMappingURL=firebase-database.service.js.map