import { Observable } from 'rxjs';
import 'zone.js';
import { invokeLazy } from './firebase.module';
export function wrapExternalPromise(promise) {
    return new Promise(function (resolve, reject) {
        promise
            .then(function (res) { return resolve(res); })
            .then(function (err) { return reject(err); });
    });
}
export function wrapPromise(promiseFact) {
    if (invokeLazy()) {
        return new Observable(function (sub) {
            wrapExternalPromise(promiseFact())
                .then(function (res) {
                sub.next(res);
                sub.complete();
            })
                .catch(function (err) { return sub.error(err); });
        });
    }
    return Observable.fromPromise(wrapExternalPromise(promiseFact()));
}
//# sourceMappingURL=utils.js.map